﻿-------------------------------------------------------------------------------
-- default layout values

nUI_UnitBar_Health_Layout =
{
	Options =
	{
		bar_name = "Health",
	},
	
	Colors =
	{
		min = { r = 0.5, g = 0, b = 0, a = 1, },
		mid = { r = 0.5, g = 0.5, b = 0, a = 1,	},
		max = { r = 0, g = 0.5, b = 0, a = 1, },
		bg = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_HealthLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_health             = nUI.Class.UnitBar_HealthLayout.prototype;

-------------------------------------------------------------------------------
-- this may look a little like a PITA, but it makes it possible to add new values
-- at any time without having to parse the existing user config and insert, etc.

function proto_health:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_health.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Health_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Health_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Health_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Health_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Health_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Health_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Health_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Health_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Health_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Health_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Health_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Health_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Health_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Health_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Health_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Health_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Health_Layout.Colors.bg.a );
	
end

-------------------------------------------------------------------------------

nUI_UnitBar_Mana_Layout =
{
	Options =
	{
		bar_name = "Mana",
	},
	
	Colors =
	{
		min   = { r = 0.75, g = 0, b = 0.25, a = 1, },
		mid   = { r = 0, g = 0, b = 0.5, a = 1, },
		max   = { r = 0, g = 0, b = 0.75, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_ManaLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_mana             = nUI.Class.UnitBar_ManaLayout.prototype;

function proto_mana:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_mana.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Mana_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Mana_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Mana_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Mana_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Mana_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Mana_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Mana_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Mana_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Mana_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Mana_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Mana_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Mana_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Mana_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Mana_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Mana_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Mana_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Mana_Layout.Colors.bg.a );
	
end

-------------------------------------------------------------------------------

nUI_UnitBar_Rage_Layout =
{
	Options =
	{
		bar_name = "Rage",
	},
	
	Colors =
	{
		min   = { r = 0.75, g = 0, b = 0, a = 1, },
		mid   = { r = 0.75, g = 0, b = 0, a = 1, },
		max   = { r = 0.75, g = 0, b = 0, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_RageLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_rage             = nUI.Class.UnitBar_RageLayout.prototype;

function proto_rage:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_rage.super.prototype.init( self, user_defined );
	
	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Rage_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Rage_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Rage_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Rage_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Rage_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Rage_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Rage_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Rage_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Rage_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Rage_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Rage_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Rage_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Rage_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Rage_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Rage_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Rage_Layout.Colors.bg.a );
	
end

-------------------------------------------------------------------------------

nUI_UnitBar_Energy_Layout =
{
	Options =
	{
		bar_name = "Energy",
	},
	Colors =
	{
		min   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		mid   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		max   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_EnergyLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_energy             = nUI.Class.UnitBar_EnergyLayout.prototype;

function proto_energy:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_energy.super.prototype.init( self, user_defined );
	
	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Energy_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Energy_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Energy_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Energy_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Energy_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Energy_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Energy_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Energy_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Energy_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Energy_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Energy_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Energy_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Energy_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Energy_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Energy_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Energy_Layout.Colors.bg.a );
	
end

-------------------------------------------------------------------------------

nUI_UnitBar_Focus_Layout =
{
	Options =
	{
		bar_name = "Focus",
	},
	
	Colors =
	{
		min   = { r = 0.5, g = 0.25, b = 0, a = 1, },
		mid   = { r = 0.5, g = 0.25, b = 0, a = 1, },
		max   = { r = 0.5, g = 0.25, b = 0, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_FocusLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_focus             = nUI.Class.UnitBar_FocusLayout.prototype;

function proto_focus:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_focus.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Focus_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Focus_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Focus_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Focus_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Focus_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Focus_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Focus_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Focus_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Focus_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Focus_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Focus_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Focus_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Focus_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Focus_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Focus_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Focus_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Focus_Layout.Colors.bg.a );
	
end

------------------------------------------------------------------------------

nUI_UnitBar_Latency_Layout =
{
	Options =
	{
		bar_name = "Latency",
	},
	
	Colors =
	{
		min   = { r = 0, g = 0, b = 0.98, a = 1, },
		mid   = { r = 0, g = 0, b = 0.98, a = 1, },
		max   = { r = 0, g = 0, b = 0.98, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
		animation = "";
		overlay   = "Interface\\AddOns\\nUI\\Bars\\Art\\nUI_BarOverlay2.blp",
	},
};

nUI.Class.UnitBar_LatencyLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_latency             = nUI.Class.UnitBar_LatencyLayout.prototype;

function proto_latency:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_focus.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Latency_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Latency_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Latency_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Latency_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Latency_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Latency_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Latency_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Latency_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Latency_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Latency_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Latency_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Latency_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Latency_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Latency_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Latency_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Latency_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Latency_Layout.Colors.bg.a );
	

end

-------------------------------------------------------------------------------

nUI_UnitBar_Casting_Layout =
{
	Options =
	{
		bar_name = "Casting",
	},
	
	Colors =
	{
		min   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		mid   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		max   = { r = 0.75, g = 0.75, b = 0, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_CastingLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_casting             = nUI.Class.UnitBar_CastingLayout.prototype;

function proto_casting:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_casting.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Casting_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Casting_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Casting_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Casting_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Casting_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Casting_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Casting_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Casting_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Casting_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Casting_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Casting_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Casting_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Casting_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Casting_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Casting_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Casting_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Casting_Layout.Colors.bg.a );
	
end

-------------------------------------------------------------------------------

nUI_UnitBar_Channeling_Layout =
{
	Options =
	{
		bar_name = "Channeling",
	},
	
	Colors =
	{
		min   = { r = 0, g = 0.75, b = 0.25, a = 1, },
		mid   = { r = 0, g = 0.75, b = 0.25, a = 1, },
		max   = { r = 0, g = 0.75, b = 0.25, a = 1, },
		bg    = { r = 0, g = 0, b = 0, a = 1, },
	},
};

nUI.Class.UnitBar_ChannelingLayout = nUI.Class:CreatePrototype( nUI.Class.StatusLayout );
local proto_channeling             = nUI.Class.UnitBar_ChannelingLayout.prototype;

function proto_channeling:init( user_defined )

	if not user_defined then user_defined = {}; end
	if not user_defined.Options then user_defined.Options = {}; end
	if not user_defined.Colors then user_defined.Colors = {}; end
	if not user_defined.Colors.max then user_defined.Colors.nax = {}; end
	if not user_defined.Colors.mid then user_defined.Colors.mid = {}; end
	if not user_defined.Colors.min then user_defined.Colors.min = {}; end
	if not user_defined.Colors.bg then user_defined.Colors.bg = {}; end
	
	proto_channeling.super.prototype.init( self, user_defined );
	
	self.Options.bar_name = user_defined.Options.bar_name or nUI_UnitBar_Casting_Layout.Options.bar_name;

	self.Colors.max.r = tonumber( user_defined.Colors.max.r or nUI_UnitBar_Channeling_Layout.Colors.max.r );
	self.Colors.max.g = tonumber( user_defined.Colors.max.g or nUI_UnitBar_Channeling_Layout.Colors.max.g );
	self.Colors.max.b = tonumber( user_defined.Colors.max.b or nUI_UnitBar_Channeling_Layout.Colors.max.b );
	self.Colors.max.a = tonumber( user_defined.Colors.max.a or nUI_UnitBar_Channeling_Layout.Colors.max.a );

	self.Colors.mid.r = tonumber( user_defined.Colors.mid.r or nUI_UnitBar_Channeling_Layout.Colors.mid.r );
	self.Colors.mid.g = tonumber( user_defined.Colors.mid.g or nUI_UnitBar_Channeling_Layout.Colors.mid.g );
	self.Colors.mid.b = tonumber( user_defined.Colors.mid.b or nUI_UnitBar_Channeling_Layout.Colors.mid.b );
	self.Colors.mid.a = tonumber( user_defined.Colors.mid.a or nUI_UnitBar_Channeling_Layout.Colors.mid.a );

	self.Colors.min.r = tonumber( user_defined.Colors.min.r or nUI_UnitBar_Channeling_Layout.Colors.min.r );
	self.Colors.min.g = tonumber( user_defined.Colors.min.g or nUI_UnitBar_Channeling_Layout.Colors.min.g );
	self.Colors.min.b = tonumber( user_defined.Colors.min.b or nUI_UnitBar_Channeling_Layout.Colors.min.b );
	self.Colors.min.a = tonumber( user_defined.Colors.min.a or nUI_UnitBar_Channeling_Layout.Colors.min.a );

	self.Colors.bg.r = tonumber( user_defined.Colors.bg.r or nUI_UnitBar_Channeling_Layout.Colors.bg.r );
	self.Colors.bg.g = tonumber( user_defined.Colors.bg.g or nUI_UnitBar_Channeling_Layout.Colors.bg.g );
	self.Colors.bg.b = tonumber( user_defined.Colors.bg.b or nUI_UnitBar_Channeling_Layout.Colors.bg.b );
	self.Colors.bg.a = tonumber( user_defined.Colors.bg.a or nUI_UnitBar_Channeling_Layout.Colors.bg.a );
	
end
